//+------------------------------------------------------------------+
//|                                                        Pivot.mq4 |
//|                                          Copyright  2011, Sibkis|
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, Sibkis"
#include <stdlib.mqh>

extern double     MaxLoss    =  10;
extern double     TakeProfit = 120;  
extern double     TrailingStop = 35; 
extern double     Lots = 0.01;
extern int        slippage=6;   	//slippage for market order processing
extern int        MAGICNUM=187233;

extern string  About = "<<< Instant Trade Analyzer >>>";

extern string  AnalyzerSetting = "<<< Analyzer Setting >>>";
extern bool    ChartSymbolOnly = false;
extern int     SpecificMagic = 0;

extern bool    UsePeriod = false;
extern string  From = "2009.01.01";
extern string  Till = "2012.02.01";

extern string  KellySetting = "<<< Optimal f (Kelly) Setting >>>";
extern double  Fractional_Kelly = 0.25;
extern int     StopLoss_for_Kellylot = 100;

extern string  SkipCommentSetting = "<<< Skip Comment Setting >>>";
extern string  SkipComment_1 = "Deposit";
extern string  SkipComment_2 = "";
extern string  SkipComment_3 = "";
extern string  SkipComment_4 = "";
extern string  SkipComment_5 = "";

string EANAME = "Instant Trade Analyzer";

string SkipComment[];
int SkipComments;

int DQ_ADJUST []  = { 0 , 0 , 1 , 10 , 1 , 10 , 100 };
int DQADJ, Ldig, DIGITS;

bool   buysig,sellsig; 
int    ttime,total, Current;
string TradeSymbol;
double dXPoint=1;
//+------------------------------------------------------------------+
int init(){
      if (Digits==3||Digits==5){
            dXPoint=10;
         }
      if (Digits==3||Digits==5){
            dXPoint=10;
            int SLIPPAGE=slippage*dXPoint;
         }  
   DIGITS = MarketInfo(Symbol(),MODE_DIGITS);
   DQADJ = DQ_ADJUST [ DIGITS ];

   Ldig = 2;
   if(MarketInfo(Symbol(),MODE_MINLOT) > 0.07) Ldig = 1;
   if(MarketInfo(Symbol(),MODE_MINLOT) > 0.7) Ldig = 0;

   int i=0;
   if(SkipComment_1 != "") { SkipComment[i] = SkipComment_1; i++; }
   if(SkipComment_2 != "") { SkipComment[i] = SkipComment_2; i++; }
   if(SkipComment_3 != "") { SkipComment[i] = SkipComment_3; i++; }
   if(SkipComment_4 != "") { SkipComment[i] = SkipComment_4; i++; }
   if(SkipComment_5 != "") { SkipComment[i] = SkipComment_5; i++; }

   SkipComments = i;

   Trade_Analyzer();        
          
//----
   return(0);
 }
//+------------------------------------------------------------------+
//| deinit
//+------------------------------------------------------------------+
int deinit()
{
   Comment("");
   return(0);
}
//+------------------------------------------------------------------+
//| Calculate open positions                                         |
//+------------------------------------------------------------------+
int CalculateCurrentOrders(string symbol)
  {
   int countorders=0;
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol())
        {
         countorders++;
        }
     }
//---- return orders volume
   return(countorders);
  }

//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForSignals(string symbol) {
      
      double h = iHigh(NULL,0,1);
      double l = iLow(NULL,0,1);
      double c = iClose(NULL,0,1);
      double o = iOpen(NULL,0,0);      
      double P = (h+l+c)/3;

      double Buy1_1 = Bid;
      double Buy1_2 = P;

      double Sell1_1 = Ask;
      double Sell1_2 = P;

	
      sellsig=false;
      buysig=false;
      //if (sell>0) {
      if (Sell1_1 <= Sell1_2) {
         sellsig=true;
      }
      //if (buy>0) {
      if (Buy1_1 >= Buy1_2) {
         buysig=true;
      }
}

void CheckForOpen(string symbol) {
   int    res;
   double h = iHigh(NULL,0,1);
   double l = iLow(NULL,0,1);
  
   double StopLoss = (h-l)/dXPoint/Point;
//---- sell conditions
   if(sellsig && ttime!=Time[0])  {
      res=OrderSend(symbol,OP_SELL,Lots,Bid,slippage,Bid+(StopLoss*dXPoint)*Point,Bid-(TakeProfit*dXPoint)*Point,"Pivot Sell",MAGICNUM,0,Red);
   	if (res<0) Print("Error opening SELL order : ",ErrorDescription(GetLastError()));
      ttime=Time[0];
      return;
   }
//---- buy conditions
   if(buysig && ttime!=Time[0])  {
      res=OrderSend(symbol,OP_BUY,Lots,Ask,slippage,Ask-(StopLoss*dXPoint)*Point,Ask+(TakeProfit*dXPoint)*Point,"Pivot Buy",MAGICNUM,0,Blue);
   	if (res<0) Print("Error opening BUY order : ",ErrorDescription(GetLastError()));
      ttime=Time[0];
      return;
   }
}
  
  
  
//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose(string symbol)  {
      double h = iHigh(NULL,0,1);
      double l = iLow(NULL,0,1);
      double c = iClose(NULL,0,1);
      double o = iOpen(NULL,0,0);      
      double P = (h+l+c)/3;

      double Buy1_1 = Bid;
      double Buy1_2 = h;

      double Sell1_1 = Bid;
      double Sell1_2 = l;
	total=OrdersTotal();
       for(int i=0;i<OrdersTotal();i++){
         if ( OrderSelect (i, SELECT_BY_POS) == false )  continue;
         if ( OrderSymbol() != TradeSymbol || OrderMagicNumber() != MAGICNUM )  continue;
      //---- check order type 
      if(OrderType()==OP_BUY)
        {
         if (Sell1_1 <= Sell1_2) {
            OrderClose(OrderTicket(),OrderLots(),Bid,slippage,White);
         }
         break;
        }
      if(OrderType()==OP_SELL)
        {
         if (Buy1_1 >= Buy1_2) {
            OrderClose(OrderTicket(),OrderLots(),Ask,slippage,White);
         }
         break;
        }
     }
}


//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
void start()  {

   //---- check for history and trading
   if(Bars<100 || IsTradeAllowed()==false) return;
	TradeSymbol=Symbol();
   //---- check for signals
   CheckForSignals(TradeSymbol);
   //---- calculate open orders by current symbol
   if (CalculateCurrentOrders(TradeSymbol)==0) 
   CheckForOpen(TradeSymbol);
   else
   CheckForClose(TradeSymbol);
	TrailStop(TradeSymbol);
	CheckForCloseAll(TradeSymbol);
	
	DIGITS = MarketInfo(Symbol(),MODE_DIGITS);
   DQADJ = DQ_ADJUST [ DIGITS ];
   Ldig = 2;
   if(MarketInfo(Symbol(),MODE_MINLOT) > 0.07) Ldig = 1;
   if(MarketInfo(Symbol(),MODE_MINLOT) > 0.7) Ldig = 0;
   int i=0;
   if(SkipComment_1 != "") { SkipComment[i] = SkipComment_1; i++; }
   if(SkipComment_2 != "") { SkipComment[i] = SkipComment_2; i++; }
   if(SkipComment_3 != "") { SkipComment[i] = SkipComment_3; i++; }
   if(SkipComment_4 != "") { SkipComment[i] = SkipComment_4; i++; }
   if(SkipComment_5 != "") { SkipComment[i] = SkipComment_5; i++; }
   SkipComments = i;
   Trade_Analyzer();
   }
//+------------------------------------------------------------------+
//| Trade Analyzer
//+------------------------------------------------------------------+
void Trade_Analyzer()
{
   string ln = "\n";
   string DAAAAASH = "---------------------------------------------------------------" +ln;

   double BUY_TRADES = Trades(0);
   double SELL_TRADES = Trades(1);
   double TOTAL_TRADES = BUY_TRADES + SELL_TRADES;
   
   if(OrdersHistoryTotal() < 1 || TOTAL_TRADES < 0.9)
   {
      Comment( DAAAAASH + EANAME +ln+ DAAAAASH + "No History to analyze." );
      return(0);
   }

   string COMMENT = "";

// Analyzer Condition --------------------------------------

   // Period
   int PeriodStart = PeriodSearch("Start");
   int PeriodEnd = PeriodSearch("End");
   double PERIOD = PeriodEnd - PeriodStart;

   double PERIODinDAYS = PERIOD/86400;

   if(UsePeriod) COMMENT = COMMENT + "Period : "+ TS(StrToTime(From),"Day") +" - "+ TS(StrToTime(Till),"Day")+" ("+DS2(PERIODinDAYS)+"days)" +ln;
   if(!UsePeriod) COMMENT = COMMENT + "Period : "+ TS(PeriodStart,"Day") +" - "+ TS(PeriodEnd,"Day")+" ("+DS2(PERIODinDAYS)+"days)" +ln;

   // Symbol
   string SYMBOL = "All Symbol";
   if(ChartSymbolOnly) SYMBOL = "Chart Symbol Only ("+Symbol()+")";
   COMMENT = COMMENT + "Symbol : " + SYMBOL +ln;

   // Magic
   string MAGIC = "All Magic";
   if(SpecificMagic > 0) MAGIC = SpecificMagic + " Only";
   COMMENT = COMMENT + "Magic : " + MAGIC +ln;
   
   COMMENT = COMMENT + DAAAAASH; // ---------------------------------------------------------------

// Statistics --------------------------------------

   double BUY_WINS = Wins(0); double BUY_LOSSES = BUY_TRADES - BUY_WINS; 
   double SELL_WINS = Wins(1); double SELL_LOSSES = SELL_TRADES - SELL_WINS; 
   double TOTAL_WINS = BUY_WINS + SELL_WINS; double TOTAL_LOSSES = TOTAL_TRADES - TOTAL_WINS; 

   // Winning Average
   double WinAv_Total = 0.0;
   if(TOTAL_TRADES > 0.001) WinAv_Total = TOTAL_WINS / TOTAL_TRADES;

   double WinAv_Buy = 0.0;
   if(BUY_TRADES > 0.001) WinAv_Buy = BUY_WINS / BUY_TRADES;
   
   double WinAv_Sell = 0.0;
   if(SELL_TRADES > 0.001) WinAv_Sell = SELL_WINS / SELL_TRADES;

   double TradeFrequency = 0.0;
   if(PERIODinDAYS > 0.001) TradeFrequency = TOTAL_TRADES / PERIODinDAYS;

   COMMENT = COMMENT + "Trades : " + DS0(TOTAL_TRADES) +" (Total) / "+DS0(BUY_TRADES) +" (buy) / "+DS0(SELL_TRADES) +" (sell)" +ln;
   COMMENT = COMMENT + "Trade Frequency : "+ DS2( TradeFrequency ) + " trades / day"+ln;

   COMMENT = COMMENT + "Win. Average (Total) : " + DS2(WinAv_Total*100) +"%"+ln;
   COMMENT = COMMENT + "Win. Average (Buy) : " + DS2(WinAv_Buy*100) +"%"+ln;
   COMMENT = COMMENT + "Win. Average (Sell) : " + DS2(WinAv_Sell*100) +"%"+ln;

   COMMENT = COMMENT + DAAAAASH; // ---------------------------------------------------------------

   // Average P/L
   double Buy_Profit = Profit(0);
   double Sell_Profit = Profit(1);
   double Total_Profit = Buy_Profit + Sell_Profit;
   double Buy_Loss = Loss(0);
   double Sell_Loss = Loss(1);
   double Total_Loss = Buy_Loss + Sell_Loss;

   double Total_PL = Total_Profit - Total_Loss;

   double Av_Profit_Total = 0.0;
   if(TOTAL_WINS > 0.001) Av_Profit_Total = Total_Profit / TOTAL_WINS;

   double Av_Loss_Total = 0.0;
   if(TOTAL_LOSSES > 0.001) Av_Loss_Total = Total_Loss / TOTAL_LOSSES;

   double PL_RATIO_Total = 0.0;
   if(Av_Loss_Total > 0.001) PL_RATIO_Total = Av_Profit_Total / Av_Loss_Total;

   COMMENT = COMMENT + "Total P/L : "+DS2(Total_PL) +" "+AccountCurrency() +ln;
   COMMENT = COMMENT + "Average Win : "+DS2(Av_Profit_Total) +" "+AccountCurrency() +ln;
   COMMENT = COMMENT + "Average Loss : "+DS2(Av_Loss_Total) +" "+AccountCurrency() +ln;
   COMMENT = COMMENT + "Profit / Loss Ratio : "+DS2(PL_RATIO_Total) +ln;

   COMMENT = COMMENT + DAAAAASH; // ---------------------------------------------------------------

// Yardsticks ---------------------------------------------------------------------

   // Profit Factor
   double ProfitFactor = 0.0;
   if(Total_Loss > 0.001) ProfitFactor = Total_Profit / Total_Loss;
   COMMENT = COMMENT + "Profit Factor : "+DS2(ProfitFactor) +ln;

   // Success Score
   COMMENT = COMMENT + "Success Score : "+DS2(PL_RATIO_Total * WinAv_Total * 100) +ln;
   
   // BreakEven Rate
   double Recovery = 0.0;
   if(Av_Profit_Total > 0.001) Recovery = Av_Loss_Total / Av_Profit_Total;

   double BreakEvenRate = Recovery / (1 + Recovery);
   COMMENT = COMMENT + "BreakEven Rate : "+DS2(BreakEvenRate * 100) + "%" +ln;

   COMMENT = COMMENT + DAAAAASH; // ---------------------------------------------------------------

   // Optimal f (Kelly)
   double Optimal_f = 0.0;
   if(PL_RATIO_Total > 0.001) Optimal_f = ( (PL_RATIO_Total + 1) * WinAv_Total - 1 ) / PL_RATIO_Total;
   COMMENT = COMMENT + "Optimal f (Kelly) : "+DS2(Optimal_f * 100) +"%" +ln;
   
   if(Fractional_Kelly < 0.9999) 
   COMMENT = COMMENT + "Fractional Kelly ("+DS2(Fractional_Kelly)+") : "+DS2(Optimal_f*Fractional_Kelly*100) +"%" +ln;

   string Fractional = ""; if(Fractional_Kelly < 0.9999) Fractional = ", Fractional";

   double Kellylot = 0.0;
   if(StopLoss_for_Kellylot>0.001) Kellylot = (AccountBalance() * Optimal_f*Fractional_Kelly) / ( MarketInfo(Symbol(),MODE_TICKVALUE) * StopLoss_for_Kellylot * DQADJ );
   COMMENT = COMMENT + "Risk by Optimal f : "+DoubleToStr(Kellylot,Ldig) +" lot (SL : "+StopLoss_for_Kellylot+"pips"+Fractional+")" +ln;

   Comment(
            DAAAAASH + EANAME +ln+
            DAAAAASH + COMMENT
          );
}  

//+------------------------------------------------------------------+
//| DS2 (string) double Val
//+------------------------------------------------------------------+
string DS2(double Val)
{
   return(DoubleToStr(Val,2));
}

//+------------------------------------------------------------------+
//| DS0 (string) double Val
//+------------------------------------------------------------------+
string DS0(double Val)
{
   return(DoubleToStr(Val,0));
}

//+------------------------------------------------------------------+
//| TS (string) int SEC
//+------------------------------------------------------------------+
string TS(int SEC, string Mode)
{
   if(Mode == "Day") return( TimeToStr(SEC, TIME_DATE) );
   if(Mode == "Min") return( TimeToStr(SEC, TIME_DATE|TIME_MINUTES) );
}

//+------------------------------------------------------------------+
//| PeriodSearch (datetime)
//+------------------------------------------------------------------+
datetime PeriodSearch(string Mode)
{
   datetime PeriodStart = 161059999999;
   datetime PeriodEnd = 0;

   for(int i=0; i<OrdersHistoryTotal(); i++)
   {
      if( !OrderSelect(i, SELECT_BY_POS, MODE_HISTORY) ) continue; // select check
      if( OrderType() > 1) continue; // order type check
      if( IsSkip( OrderSymbol(), OrderMagicNumber(), OrderComment(), OrderOpenTime(), OrderCloseTime()) ) continue;

      if(Mode == "Start") PeriodStart = MathMin(PeriodStart,OrderCloseTime());
      if(Mode == "End") PeriodEnd = MathMax(PeriodEnd,OrderCloseTime());
   }

   if(Mode == "Start") return(PeriodStart);
   if(Mode == "End") return(PeriodEnd);
}  

//+------------------------------------------------------------------+
//| IsSkip (bool)
//+------------------------------------------------------------------+
bool IsSkip(string ORDERSYMBOL, int ORDERMAGIC, string ORDERCOMMENT, datetime ORDEROPENTIME, datetime ORDERCLOSETIME)
{
   if(ChartSymbolOnly && Symbol() != ORDERSYMBOL) return(true); // symbol check
   if(SpecificMagic > 0 && ORDERMAGIC != SpecificMagic) return(true); // magic check
   if( IsSkipComment( ORDERCOMMENT ) ) return(true); // comment check
   if( UsePeriod && IsOutsidePeriod( ORDEROPENTIME, ORDERCLOSETIME ) ) return(true); // period check

   return(false);
}  

//+------------------------------------------------------------------+
//| IsSkipComment (bool)
//+------------------------------------------------------------------+
bool IsSkipComment(string OrdComment)
{
   bool IsSkipComment = false;
   for(int i=0; i<SkipComments; i++) if(StringFind(OrdComment, SkipComment[i]) != -1) IsSkipComment = true;

   return(IsSkipComment);
}  

//+------------------------------------------------------------------+
//| IsOutsidePeriod (bool)
//+------------------------------------------------------------------+
bool IsOutsidePeriod(datetime OPEN, datetime CLOSE)
{
   bool OutsidePeriod = false;
   if(OPEN < StrToTime(From)) OutsidePeriod = true;
   if(CLOSE > StrToTime(Till)) OutsidePeriod = true;

   return(OutsidePeriod);
}  

//+------------------------------------------------------------------+
//| Trades (int)
//+------------------------------------------------------------------+
int Trades(int OrdType)
{
   int Trades = 0;

   for(int i=0; i<OrdersHistoryTotal(); i++)
   {
      if( !OrderSelect(i, SELECT_BY_POS, MODE_HISTORY) ) continue; // select check
      if( OrderType() != OrdType ) continue; // order type check
      if( IsSkip( OrderSymbol(), OrderMagicNumber(), OrderComment(), OrderOpenTime(), OrderCloseTime()) ) continue;
      
      Trades++;
   }

   return(Trades);
}  

//+------------------------------------------------------------------+
//| Wins (int)
//+------------------------------------------------------------------+
int Wins(int OrdType)
{
   int Wins = 0;

   for(int i=0; i<OrdersHistoryTotal(); i++)
   {
      if( !OrderSelect(i, SELECT_BY_POS, MODE_HISTORY) ) continue; // select check
      if( OrderType() != OrdType ) continue; // order type check
      if( IsSkip( OrderSymbol(), OrderMagicNumber(), OrderComment(), OrderOpenTime(), OrderCloseTime()) ) continue;
      
      if(OrderProfit()+OrderSwap()+OrderCommission() >= 0) Wins++;
   }

   return(Wins);
}  

//+------------------------------------------------------------------+
//| Profit (double)
//+------------------------------------------------------------------+
double Profit(int OrdType)
{
   double Profit = 0.0;

   for(int i=0; i<OrdersHistoryTotal(); i++)
   {
      if( !OrderSelect(i, SELECT_BY_POS, MODE_HISTORY) ) continue; // select check
      if( OrderType() != OrdType ) continue; // order type check
      if( IsSkip( OrderSymbol(), OrderMagicNumber(), OrderComment(), OrderOpenTime(), OrderCloseTime()) ) continue;
      
      if(OrderProfit()+OrderSwap()+OrderCommission() >= 0) Profit += (OrderProfit()+OrderSwap()+OrderCommission());
   }

   return(Profit);
}

//+------------------------------------------------------------------+
//| Loss (double)
//+------------------------------------------------------------------+
double Loss(int OrdType)
{
   double Loss = 0.0;

   for(int i=0; i<OrdersHistoryTotal(); i++)
   {
      if( !OrderSelect(i, SELECT_BY_POS, MODE_HISTORY) ) continue; // select check
      if( OrderType() != OrdType ) continue; // order type check
      if( IsSkip( OrderSymbol(), OrderMagicNumber(), OrderComment(), OrderOpenTime(), OrderCloseTime()) ) continue;

      if(OrderProfit()+OrderSwap()+OrderCommission() < 0) Loss -= (OrderProfit()+OrderSwap()+OrderCommission());
   }

   return(Loss);
}
//+------------------------------------------------------------------+
void TrailStop(string mySymbol) {
   double StopLoss,trailing;
   if ( TrailingStop>=8 ) {
   	trailing=(TrailingStop*dXPoint)*Point;
      for (int i = 0; i < OrdersTotal(); i++) {
         if ( OrderSelect (i, SELECT_BY_POS) == false )  continue;
         if ( OrderSymbol() != mySymbol || OrderMagicNumber() != MAGICNUM )  continue;
         if ( OrderType() == OP_BUY ) {
            StopLoss = Bid-trailing;
            if ( StopLoss > OrderStopLoss() ) {
               OrderModify (OrderTicket(), OrderOpenPrice(), StopLoss, OrderTakeProfit(), 0, White);
            }
         }
   
         if ( OrderType() == OP_SELL ) {
            StopLoss = Ask+trailing;
            if ( StopLoss < OrderStopLoss() ) {
               OrderModify (OrderTicket(), OrderOpenPrice(), StopLoss, OrderTakeProfit(), 0, Gold);
            }
         }
      }
   }
   return;
}
//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForCloseAll(string symbol)  {
 double pcnt =( (AccountEquity()-AccountBalance()) / AccountBalance())*100;
 if(pcnt>MaxLoss){ 
 int total = OrdersTotal();
  for(int i=total-1;i>=0;i--) {
    OrderSelect(i, SELECT_BY_POS);
    int type   = OrderType();
    bool result = false;   
    switch(type){
      //Close opened long positions
      case OP_BUY       : result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
                          break;     
      //Close opened short positions
      case OP_SELL      : result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
                          break;
      //Close pending orders
      case OP_BUYLIMIT  :
      case OP_BUYSTOP   :
      case OP_SELLLIMIT :
      case OP_SELLSTOP  : result = OrderDelete( OrderTicket() );
    }   
    if(result == false)
    {
      Alert("Order " , OrderTicket() , " failed to close. Error:" , GetLastError() );
      Sleep(3000);
      }  
     }
     Print("ALL ORDERS CLOSE-->Locked in on Profits");
    }
   return(0);
  }